>From c8eba732a1a26b3f275b038d1e9cc3aae525e25e Mon Sep 17 00:00:00 2001
From: =?utf-8?q?Marian=20=C4=8Eurkovi=C4=8D?= <md@bts.sk>
Date: Thu, 3 Sep 2009 16:58:17 +0200
Subject: [PATCH] Report RTP packet loss and make PIM Asserts only a debug event (Closes: #2718)

---
 modules/access/rtp/session.c |   10 +++-------
 1 files changed, 3 insertions(+), 7 deletions(-)

diff --git a/modules/access/rtp/session.c b/modules/access/rtp/session.c
index a6925f8..f3f228b 100644
--- a/modules/access/rtp/session.c
+++ b/modules/access/rtp/session.c
@@ -351,11 +351,6 @@ rtp_queue (demux_t *demux, rtp_session_t *session, block_t *block)
         int delta_seq = seq - rtp_seq (prev);
         if (delta_seq < 0)
             break;
-        if (delta_seq == 0)
-        {
-            msg_Dbg (demux, "duplicate packet (sequence: %"PRIu16")", seq);
-            goto drop; /* duplicate */
-        }
         pp = &prev->p_next;
     }
     block->p_next = *pp;
@@ -383,11 +378,12 @@ rtp_decode (demux_t *demux, const rtp_session_t *session, rtp_source_t *src)
     if (delta_seq != 0)
     {
         if (delta_seq >= 0x8000)
-        {   /* Unrecoverable if later packets have already been dequeued */
-            msg_Warn (demux, "ignoring late packet (sequence: %"PRIu16")",
+        {   /* Trash too late packets (and PIM Assert duplicates) */
+            msg_Dbg (demux, "ignoring late packet (sequence: %"PRIu16")",
                       rtp_seq (block));
             goto drop;
         }
+        msg_Warn (demux, "%"PRIu16" packet(s) lost", delta_seq);
         block->i_flags |= BLOCK_FLAG_DISCONTINUITY;
     }
     src->last_seq = rtp_seq (block);
-- 
1.5.3.3

